F - Prime Path POJ - 3126

 

F - Prime Path

POJ - 3126

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.

1033
1733
3733
3739
3779
8779
8179

The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

AC代码1:

#include<set>
#include<map>
#include<cmath>
#include<queue>
#include<string>
#include<cstdio>
#include<cstring>
#include<sstream>
#include<cstdlib>
#include<cstring>
#include<sstream>
#include<iostream>
#include<algorithm>

using namespace std;
const int maxn = 10050;
const int INF = 0x3f3f3f3f;
const int mod = 7;
typedef long long ll;
#define PI 3.1415927


int n, m;
int t;
bool isPrime[maxn];
bool vis[maxn];
bool flag = false;
int ans = INF;
struct Node
{
    int num[4];
    int step;
};
void bfs(int x)
{
    Node star;
    int cnt = 3;
    while(x)
    {
        star.num[cnt--] = x%10;
        x/=10;
    }
    star.step = 0;
    queue<Node> que;
    que.push(star);
    while(!que.empty())
    {
        Node next = que.front();
        que.pop();
        cnt = 3;
        int nu = next.num[0]*1000+next.num[1]*100+next.num[2]*10+next.num[3];
        if(nu == m)
        {
            ans = next.step;
            break;
        }
        for(int i = 0; i < 4; ++i)
        {
            for(int j = 0; j <=9; j++)
            {
                if((i == 0 && j == 0) || (next.num[i]==j))
                {
                    continue;
                }
                else
                {
                    int numb = 0;
                    int temp = 1000;
                    for(int k = 0; k < 4; ++k)
                    {
                        if(k!=i)
                        {
                            numb += next.num[k]*temp;
                            temp /= 10;
                        }
                        else
                        {
                            numb += j*temp;
                            temp /= 10;
                        }
                    }
                    if(isPrime[numb] && !vis[numb])
                    {
                        vis[numb] = true;
                        cnt = 3;
                        while(numb)
                        {
                            star.num[cnt--] = numb%10;
                            numb/=10;
                        }
                        star.step = next.step+1;
                        que.push(star);
                    }
                }
            }
        }
    }
}
int main()
{
    memset(isPrime, true, sizeof(isPrime));
    for(int i = 2; i < maxn; ++i)
    {
        if(isPrime[i])
        {
            for(int j = i*i; j < maxn; j+=i)
            {
                isPrime[j] = false;
            }
        }
    }
    scanf("%d", &t);
    while(t--)
    {
        ans = 0;
        memset(vis,0,sizeof(vis));
        scanf("%d%d",&n,&m);
        if(n == m)
        {
            printf("0\n");
            continue;
        }
        bfs(n);
        printf("%d\n", ans);
    }
    return 0;
}

[点击并拖拽以移动]


AC代码2:

#include<set>
#include<map>
#include<cmath>
#include<queue>
#include<string>
#include<cstdio>
#include<cstring>
#include<sstream>
#include<cstdlib>
#include<cstring>
#include<sstream>
#include<iostream>
#include<algorithm>

using namespace std;
const int maxn = 10050;
const int INF = 0x3f3f3f3f;
const int mod = 7;
typedef long long ll;
#define PI 3.1415927


int n, m;
int t;
bool isPrime[maxn];
bool vis[maxn];
bool flag = false;
int ans = INF;
struct Node
{
    int num[4];
    int step;
};
void bfs(int x)
{
    Node star;
    int cnt = 3;
    while(x)
    {
        star.num[cnt--] = x%10;
        x/=10;
    }
    star.step = 0;
    queue<Node> que;
    que.push(star);
    while(!que.empty())
    {
        Node next = que.front();
        que.pop();
        cnt = 3;
        int nu = next.num[0]*1000+next.num[1]*100+next.num[2]*10+next.num[3];
        if(nu == m)
        {
            ans = next.step;
            break;
        }
        for(int i = 0; i < 4; ++i)
        {
            for(int j = 0; j <=9; j++)
            {
                if((i == 0 && j == 0) || (next.num[i]==j))
                {
                    continue;
                }
                else
                {
                    int numb = 0;
                    int temp = 1000;
                    for(int k = 0; k < 4; ++k)
                    {
                        if(k!=i)
                        {
                            numb += next.num[k]*temp;
                            temp /= 10;
                        }
                        else
                        {
                            numb += j*temp;
                            temp /= 10;
                        }
                    }
                    if(isPrime[numb] && !vis[numb])
                    {
                        vis[numb] = true;
                        cnt = 3;
                        while(numb)
                        {
                            star.num[cnt--] = numb%10;
                            numb/=10;
                        }
                        star.step = next.step+1;
                        que.push(star);
                    }
                }
            }
        }
    }
}
int main()
{
    memset(isPrime, true, sizeof(isPrime));
    for(int i = 2; i < maxn; ++i)
    {
        if(isPrime[i])
        {
            for(int j = i*i; j < maxn; j+=i)
            {
                isPrime[j] = false;
            }
        }
    }
    scanf("%d", &t);
    while(t--)
    {
        ans = 0;
        memset(vis,0,sizeof(vis));
        scanf("%d%d",&n,&m);
        if(n == m)
        {
            printf("0\n");
            continue;
        }
        bfs(n);
        printf("%d\n", ans);
    }
    return 0;
}

猜你喜欢

转载自blog.csdn.net/qq_40758751/article/details/81325565